-- Pretty Pink Slot
-- Background Muzak made in Renoise

-- Special Thanks goes to:
-- Creator of Terminal Vector Font
-- Dr Petter (sfxr rocks!)
-- TEsound and it's creators (Ensayia and Taehl)
-- josefnpat

require"TEsound"

function love.load()
	fontname = 'TerminalVector.ttf' -- font file
	fontsize = 25 -- font size
	monofont = love.graphics.newFont( fontname, fontsize ) -- creates font
	-- setup coin reward particle system
	coinname = 'coin.png'
	coinpic = love.graphics.newImage( coinname )
	p = love.graphics.newParticleSystem( coinpic, 500 )
	p:setEmissionRate(30)
	p:setSpeed(750,1000)
	p:setGravity(200)
	p:setSizes(2, 1)
	p:setPosition(fontsize*9+7, fontsize*4+7)
	p:setLifetime(1)
	p:setParticleLife(1000)
	p:setDirection(0)
	p:setTangentialAcceleration(4000)
	p:setRadialAcceleration(-2000)
	p:stop()
	popit = false
	poptime = true
	poptimer = 0
	-- setup coin spending particle system
	s = love.graphics.newParticleSystem( coinpic, 1 )
	s:setEmissionRate(20)
	s:setSpeed(-10)
	s:setGravity(-3000)
	s:setSizes(2, 1)
	s:setPosition(fontsize*18+7, fontsize*9-7)
	s:setLifetime(1)
	s:setParticleLife(1)
	s:setDirection(0)
	s:setTangentialAcceleration(-2000,-1000)
	s:stop()
	sopit = false
	soptime = true
	soptimer = 0
	-- put variables and tables in place, defaults
	addup = 0
	subup = 0
	refreshrate = 0
	slotread = {}
	store = {}
	glyph = {}
	for i = 1,5 do 
		slotread[i] = 51
		store[i] = 51
	end
	coins = 100
	hapistate = 1
	winnings = 0
	lost = false
	done = false
	slotoutput = '♥♥♥♥♥'
	played = false
end
TEsound.playLooping("muzak.ogg", "bgm")
function love.update(dt)
	if lost or done then TEsound.stop("bgm") end
	p:start()
	p:update(dt)
	s:start()
	s:update(dt)
	if pulled then
		for i = 1, 5 do 
			slotread[i] = math.floor(math.random(100)+0.5)
		end 
	end
	if coins < 10 then hapistate = 3 end
	if hapistate == 3 and coins > 9 then hapistate = 1 end
	refreshrate = refreshrate + 1
	if refreshrate > 2 then refreshrate = 0 end
	if addup > 0 then
		if refreshrate == 0 then
			coins = coins + 5
			addup = addup - 5
			TEsound.play( "ding.ogg" )
		elseif refreshrate == 2 then
			TEsound.pause( "ding.ogg" )
			TEsound.stop( "ding.ogg" )
		end
	end
	if subup > 0 then
		if refreshrate == 0 then
			coins = coins - 5
			subup = subup - 5
			TEsound.play( "doop.ogg", "gone" )
			TEsound.volume("gone",10)
		elseif refreshrate == 2 then
			TEsound.pause( "doop.ogg" )
			TEsound.stop( "doop.ogg" )
		end
	end
	if coins < 0 then lost = true end
	TEsound.cleanup()
end
function love.keypressed(key)
	if key == 'q' and addup == 0 and subup == 0 and not lost then
		done = true
		sopit = false
		soptimer = 0
		popit = false
		poptimer = 0
		TEsound.stop("spinna")
		pulled = false
	end
	if key == ' ' and (addup == 0) and (subup == 0) and not sopit then
		if (not lost) and (not done) then
			if pulled then
				TEsound.stop("spinna")
				TEsound.play("stopspin.ogg")
				crank()
				winnings = 0
			else
				if coins - 5 < 0 then lost = true else
					TEsound.playLooping("spinning.ogg", "spinna")
					subup = 5
					s:setBufferSize( 1 )
					sopit = true
					hapistate = 1
					pulled = true
					played = true
				end
			end
		else
			coins = 100
			TEsound.playLooping("muzak.ogg", "bgm")
			lost = false
			done = false
			played = false
		end
	end
end
function vertline(xlocation, length) -- draws vertical lines
	for y = 0, length do 
		love.graphics.print( '|' , fontsize*xlocation, y*fontsize)
	end
end
function horiline(xloc, yloc) -- draws horizontal lines
	for size = 1, 5 do
		love.graphics.print( '_', fontsize*xloc+(fontsize*size), fontsize*yloc)
	end
end
function slotz(xloc, yloc)
	love.graphics.print( [[>slotz<]], fontsize*xloc, fontsize*yloc)
end
function muni(xloc, yloc)
	love.graphics.print( [[ _____ ]], fontsize*xloc, fontsize*(yloc-2))
	love.graphics.print( [[ $_☺_$ ]], fontsize*xloc, fontsize*(yloc-1)-3)
	love.graphics.print( [[ _ _ _ ]], fontsize*xloc, fontsize*(yloc-1)-3)
	love.graphics.print( "[", fontsize*xloc+7, fontsize*(yloc-1)-3)
	love.graphics.print( "      ]", fontsize*xloc-7, fontsize*(yloc-1)-3)
end
function hapi(xloc, yloc)
	if hapistate == 1 then love.graphics.print( [[\(^_^)/]], fontsize*xloc, fontsize*yloc) end
	if hapistate == 2 then love.graphics.print( [[\(0_0)/]], fontsize*xloc, fontsize*yloc) end
	if hapistate == 3 then love.graphics.print( [[\(;_;)/]], fontsize*xloc, fontsize*yloc) end
end
function crank() --cranks machine
	-- reset lever
	pulled = false
	--winnings logic
	if (glyph[1] == glyph[2] and glyph[2] == glyph[3]) or (glyph[2] == glyph[3] and glyph[3] == glyph[4]) or (glyph[3] == glyph[4] and glyph[4] == glyph[5]) then 
		if glyph[3] == 'ö' then 
			winnings = 250
			TEsound.play("yay.ogg")
		end
		if glyph[3] == '$' then winnings = 30 end
		if glyph[3] == '☺' then winnings = 15 end
		if glyph[3] == '♥' then winnings = 5 end
	end
	if (glyph[1] == glyph[2] and glyph[2] == glyph[3] and glyph[3] == glyph[4]) or (glyph[2] == glyph[3] and glyph[3] == glyph[4] and glyph[4] == glyph[5]) then 
		if glyph[3] == 'ö' then 
			winnings = 1000 
			TEsound.play("yay.ogg")
		end
		if glyph[3] == '$' then winnings = 50 end
		if glyph[3] == '☺' then winnings = 30 end
		if glyph[3] == '♥' then winnings = 10 end
	end
	if (glyph[1] == glyph[2] and glyph[2] == glyph[3] and glyph[3] == glyph[4] and glyph[4] == glyph[5]) then
		if glyph[3] == 'ö' then 
			winnings = 10000
			TEsound.play("yay.ogg")
		end
		if glyph[3] == '$' then winnings = 100 end
		if glyph[3] == '☺' then winnings = 50 end
		if glyph[3] == '♥' then winnings = 25 end
	end
	slotoutput = table.concat(glyph,nil,1,5)
	if string.find(slotoutput,"ö") and (string.find(slotoutput,"X") == nil) then
		TEsound.play("yay.ogg")
		if string.find(slotoutput,"öö") then
			winnings = winnings + 100
		else
			winnings = winnings + 25
		end
	end
	if string.find(slotoutput,"X") then 
		winnings = 0
		TEsound.play("fail.ogg","bad")
		TEsound.volume("bad",0.7)
	end
	if slotoutput == "XXXXX" then hapistate = 2 end
	p:setBufferSize( winnings/5 )
	if winnings > 0 then 
		popit = true
	end
	addup = winnings
end
function readout() -- prints slot output
	for i = 1, 5 do
		store[i] = slotread[i]
		if store[i] >= 1 and store[i] <= 2 then slotread[i] = "ö" end -- chance of ö
		if store[i] >= 3 and store[i] < 15 then slotread[i] = "$" end -- chance of $
		if store[i] >= 15 and store[i] < 45 then slotread[i] = "☺" end -- chance of ☺
		if store[i] >= 45 and store[i] < 93 then slotread[i] = "♥" end -- chance of ♥
		if store[i] >= 93 then slotread[i] = "X" end -- chance of X
		glyph[i] = slotread[i]
		love.graphics.print( slotread[i], fontsize*i+75, 107)
		slotread[i] = store[i]
	end
end
function lever() -- draw lever
	if not pulled then 
		for i = 1,3 do love.graphics.print( '/', fontsize*(i+9), fontsize*(4-i)) end
		love.graphics.print( 'o', fontsize*13, 0)
	elseif pulled then 
		for i = 1,3 do love.graphics.print( '_', fontsize*(i+9), fontsize*4) end
		love.graphics.print( 'o', fontsize*13, fontsize*4+7)
	end
end
function love.draw()
	love.graphics.setBlendMode( 'subtractive' )
	love.graphics.setBackgroundColor( 250, 120, 120 ) -- set pretty pink background :3
	love.graphics.setFont( monofont ) -- sets font
	-- slotmachine graphics (static)
	if (not lost) and (not done) then
		vertline(3, 9)
		vertline(9, 9)
		vertline(10, 8)
		love.graphics.print('/',fontsize*10-7,fontsize*9)
		horiline(3, 3)
		horiline(3, 5)
		slotz(4, 2)
		muni(4, 2)
		-- happyface
		if doingood then hapi(4, 9, 1) end
		if not doingood then hapi(4, 9, 2) end
		readout() -- slot output
		lever() -- draw lever
		-- coins total
		if coins > 9000 then love.graphics.print ("9001+", fontsize*16+10, fontsize*9) end
		if coins >= 1000 and coins < 9001 then love.graphics.print( '$' .. coins, fontsize*16+7, fontsize*9 ) end
		if coins >= 100 and coins < 1000 then love.graphics.print( '$' .. coins, fontsize*17, fontsize*9 ) end
		if coins >= 10 and coins < 100 then love.graphics.print( '$' .. coins, fontsize*18-10, fontsize*9 ) end
		if coins < 10 and coins > -1 then love.graphics.print( '$' .. coins, fontsize*18+7, fontsize*9 ) end
		-- make coins pop out (wee!)
		if popit then
			love.graphics.draw(p, 0, 0)
		end
		if sopit then
			love.graphics.draw(s, 0, 0)
		end
		if p:isFull( ) then poptime = false end
		if s:isFull( ) then soptime = false end
		if not poptime then poptimer = poptimer + 1 end
		if not soptime then soptimer = soptimer + 1 end
		if poptimer > 4400 then
			popit = false
			poptimer = 0
		end
		if soptimer > 50 then
			sopit = false
			soptimer = 0
		end
	end
	if lost then 
		love.graphics.printf( "Oh no, you are broke! You must really suck at gambling! Press space to give it another shot...", 0, 0, 500, "left") 
	end
	if done then
		if coins > 9000 then love.graphics.printf( [["Vegeta, what does the Scouter say about his Power Level?"]] .. '\n\n' .. [["... It's over 9000!!!!!"]], 0, 0, 500, "left") end
		if coins > 100 and coins <= 9000 then
			love.graphics.printf( "You finally have the courage to walk away from your terrible gambling problem, and you even make a profit while you're at it! Great job! Press space to relapse into your debilitating addiction!", 0, 0, 500, "left")
		elseif coins < 100 and coins > 0 then love.graphics.printf( "You walk from away from the casino with less than you started with. Damn! Press space to withdraw 100 dollars more from your child's college fund...", 0, 0, 500, "left")
		elseif coins == 0 then 
			done = false
			lost = true 
		elseif coins == 100 then 
			if played then love.graphics.printf( "You decide to leave while you're ahead-- Hey, wait a second! You have $100, that's what you started with! Press space to turn around and throw it all away!", 0, 0, 500, "left") end
			if not played then 
				love.graphics.printf( "You have found the truth about gambling: The only winning move is not to play. How about a nice game of chess? No? Well then, screw you! Go gamble some more, see if I care!", 0, 0, 500, "left")
			end
		end
	end
end
